#
#   COMPONENT_NAME: somx
#
#   ORIGINS: 27
#
#
#    25H7912  (C)  COPYRIGHT International Business Machines Corp. 1996
#   All Rights Reserved
#   Licensed Materials - Property of IBM
#   US Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# @(#) 1.9 src/somples.nt/somd/c/animal/vac.mak, somples.somd, som3.0, s309651d 12/20/96 17:05:24 [12/23/96 08:42:21]  

# DISCLAIMER OF WARRANTIES.
# The following [enclosed] code is sample code created by IBM
# Corporation. This sample code is not part of any standard or IBM
# product and is provided to you solely for the purpose of assisting
# you in the development of your applications.  The code is provided
# "AS IS". IBM MAKES NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT
# NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE, REGARDING THE FUNCTION OR PERFORMANCE OF
# THIS CODE.  IBM shall not be liable for any damages arising out of
# your use of the sample code, even if they have been advised of the
# possibility of such damages.
#
# DISTRIBUTION.
# This sample code can be freely distributed, copied, altered, and
# incorporated into other software, provided that it bears the above
# Copyright notice and DISCLAIMER intact.
!include  ..\..\..\vacmake.hd

INCLS = danimal.h ddog.h dldog.h dbdog.h dloc.h
IDLFILES = danimal.idl dbdog.idl ddog.idl dldog.idl dloc.idl

DEFSPEC=/DEF:danimal.def

PRIVEXELIBS = danimal.lib
DLLOBJS = danimal.od dloc.od ddog.od dldog.od dbdog.od daniinit.od
EXEOBJS = anitest.obj

all: $(SOMCORBA_DEPEND) danimal.dll anitest.exe testsvr.exe som_ir somdimpl

danimal.c: danimal.idl
	echo " "

danimal.def: *.idl
	sc -sdef -mdll=danimal.dll *.idl
danimal.exp: *.idl
	sc -sexp -mdll=danimal.dll *.idl

danimal.dll: danimal.exp $(DLLOBJS) danimal.lib
danimal.lib: danimal.def $(DLLOBJS)

danimal.od: danimal.ih danimal.h dloc.h danimal.c
ddog.od: ddog.ih ddog.h ddog.c
dldog.od: dldog.ih dldog.h dldog.c
dbdog.od: dbdog.ih dbdog.h dbdog.c
dloc.od: dloc.ih dloc.h dloc.c

testsvr.exe: testsvr.obj
testsvr.obj: $(INCLS) testsvr.c

anitest.exe: anitest.obj danimal.lib

# anitest.exe: anitest.obj danimal.lib
# 	$(LD) $(LDFLAGS) /OUT:$@ anitest.obj danimal.lib somtk.lib user32.lib gdi32.lib

anitest.obj: $(INCLS) anitest.c

##Build the initialization module from the idl files.
daniinit.od:  daniinit.c

daniinit.c: $(IDLS)
	sc -simod -mdll=danimal.dll -mimod=$@ *.idl

clnimpl:
	-regimpl -D -i aniServer1
	-del somdimpl

### -- Put the IDL descriptions into the Interface Repository.
som_ir: $(IDLFILES)
	-$(SC) -I. -sir -u -mnolock $(INCS) *.idl
	-@echo "x" > som_ir

### -- Build the DSOM Implementation Repository.
somdimpl:
	-regimpl -A -i aniServer1 -p testsvr.exe
	-regimpl -a -i aniServer1 -c dAnimal -c dDog -c dBigDog -c dLittleDog -c dLocation
	-regimpl -L -i aniServer1
	@echo x > somdimpl

clean: clnimpl
	-del som_ir
	-del som.ir
        -del d*.h
        -del daniinit.c

!include ..\..\..\vacmake.tl
