#
#   COMPONENT_NAME: somx
#
#   ORIGINS: 27
#
#
#    25H7912  (C)  COPYRIGHT International Business Machines Corp. 1996
#   All Rights Reserved
#   Licensed Materials - Property of IBM
#   US Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# @(#) 1.7 src/somples.nt/somd/c/proxy/vac.mak, somples.somd, som3.0 12/17/96 10:42:43 [12/23/96 08:40:24]  

# DISCLAIMER OF WARRANTIES.
# The following [enclosed] code is sample code created by IBM
# Corporation. This sample code is not part of any standard or IBM
# product and is provided to you solely for the purpose of assisting
# you in the development of your applications.  The code is provided
# "AS IS". IBM MAKES NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT
# NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE, REGARDING THE FUNCTION OR PERFORMANCE OF
# THIS CODE.  IBM shall not be liable for any damages arising out of
# your use of the sample code, even if they have been advised of the
# possibility of such damages.
#
# DISTRIBUTION.
# This sample code can be freely distributed, copied, altered, and
# incorporated into other software, provided that it bears the above
# Copyright notice and DISCLAIMER intact.
!include ..\..\..\vacmake.hd

INCS = -I$(SOMBASE)\include
INCLS = bar.h barproxy.h
IDLFILES = bar.idl barproxy.idl

DLLOBJS = bar.od barproxy.od initmod.od
EXEOBJS = tstproxy.obj
PRIVEXELIBS = objs.lib

DEFSPEC=/DEF:objs.def

all: $(SOMCORBA_DEPEND) objs.dll tstproxy.exe som.ir somdimpl

### -- Build the DLL.
objs.def: *.idl
	sc -sdef -mdll=objs.dll *.idl
objs.exp: *.idl
	sc -sexp -mdll=objs.dll *.idl
objs.dll: objs.exp $(DLLOBJS) objs.lib
objs.lib: objs.def $(DLLOBJS)
bar.od: bar.ih bar.h bar.c
barproxy.od: barproxy.ih barproxy.h barproxy.c

tstproxy.exe: objs.lib tstproxy.obj 
tstproxy.obj: $(INCLS) tstproxy.c

##Build the initialization module from the idl files.
initmod.od:  initmod.c

initmod.c: $(IDLS)
	sc -simod -mdll=objs.dll -mimod=$@ *.idl

### -- Put the IDL descriptions into the Interface Repository.
som.ir: som_ir
som_ir: bar.idl barproxy.idl
	-$(SC) -sir -u -mnolock $(INCS) *.idl
	echo x > som_ir

clnimpl:
	-regimpl -D -i barServer1
	-del somdimpl

### -- Build the DSOM Implementation Repository.
somdimpl:
	-regimpl -A -i barServer1
	-regimpl -a -i barServer1 -c Bar
	-regimpl -L -i barServer1
	@echo x > somdimpl

clean: clnimpl
	-del som.ir
	-del som_ir
        -del fileref
	-del initmod.c

!include ..\..\..\vacmake.tl
