#
#   COMPONENT_NAME: somx
#
#   ORIGINS: 27
#
#
#    25H7912  (C)  COPYRIGHT International Business Machines Corp. 1996
#   All Rights Reserved
#   Licensed Materials - Property of IBM
#   US Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# @(#) 1.5 src/somples.nt/somd/cpp/peer/vac.mak, somples.somd, som3.0 12/16/96 14:28:38 [12/23/96 08:40:37]  




# DISCLAIMER OF WARRANTIES.
# The following [enclosed] code is sample code created by IBM
# Corporation. This sample code is not part of any standard or IBM
# product and is provided to you solely for the purpose of assisting
# you in the development of your applications.  The code is provided
# "AS IS". IBM MAKES NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT
# NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE, REGARDING THE FUNCTION OR PERFORMANCE OF
# THIS CODE.  IBM shall not be liable for any damages arising out of
# your use of the sample code, even if they have been advised of the
# possibility of such damages.
#
# DISTRIBUTION.
# This sample code can be freely distributed, copied, altered, and
# incorporated into other software, provided that it bears the above
# Copyright notice and DISCLAIMER intact.
!include ..\..\..\vacmake.hd

INCS = -I$(SOMBASE)\include
INCLS = peerserv.xh
IDLFILES = peerserv.idl

PRIVCPPFLAGSDLL= /Ms
DLLOBJS = peerserv.od psinit.od
EXEOBJS = peer.obj
PRIVEXELIBS = peerserv.lib

DEFSPEC=/DEF:peerserv.def

PRIVLDFLAGSDLL=$(ENTRYFLAG) $(SOMINITOBJ)


all: $(SOMXH_DEPEND) peerserv.dll peer.exe som.ir somdimpl

### -- Build the DLL.
peerserv.def: peerserv.idl
peerserv.exp: peerserv.idl
peerserv.lib: peerserv.def $(DLLOBJS)
peerserv.dll: peerserv.exp $(DLLOBJS) peerserv.lib
peerserv.lib: peerserv.def $(DLLOBJS)
peerserv.od: peerserv.xih peerserv.xh peerserv.cpp

peer.exe: peerserv.lib peer.obj
peer.obj: $(INCLS) peer.cpp

### -- Build the DLL initialization file, psinit.od.
psinit.od: psinit.c

psinit.c: peerserv.idl
	sc -simod -mdll=peerserv.dll -mimod=$@ *.idl

### -- Put the IDL descriptions into the Interface Repository.
som.ir: som_ir
som_ir: peerserv.idl
	-$(SC) -sir -u -mnolock $(INCS) *.idl
	echo x > som_ir



### -- Build the DSOM Implementation Repository.
somdimpl:
	-regimpl -A -i peerServer1 -p peer
	-regimpl -a -i peerServer1 -c PeerServer
	-regimpl -A -i peerServer2 -p peer
	-regimpl -a -i peerServer2 -c PeerServer
	-regimpl -l -i peerServer1 -i peerServer2
    @echo "" > somdimpl


# Cleanup the DSOM Implementation Repository.
cleanimpl:
	-regimpl -D -i peerServer1
	-regimpl -D -i peerServer2
        -erase somdimpl

clean: cleanimpl
	-del som.ir
	-del som_ir
	-del psinit.c

!include ..\..\..\vacmake.tl
