#
#   COMPONENT_NAME: somx
#
#   ORIGINS: 27
#
#
#    25H7912  (C)  COPYRIGHT International Business Machines Corp. 1996
#   All Rights Reserved
#   Licensed Materials - Property of IBM
#   US Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#   @(#) 1.5 src/somples.nt/somd/cpp/stack/vac.mak, somples.somd, som3.0 12/16/96 14:28:40 [12/23/96 08:40:39]




# DISCLAIMER OF WARRANTIES.
# The following [enclosed] code is sample code created by IBM
# Corporation. This sample code is not part of any standard or IBM
# product and is provided to you solely for the purpose of assisting
# you in the development of your applications.  The code is provided
# "AS IS". IBM MAKES NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT
# NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE, REGARDING THE FUNCTION OR PERFORMANCE OF
# THIS CODE.  IBM shall not be liable for any damages arising out of
# your use of the sample code, even if they have been advised of the
# possibility of such damages.
#
# DISTRIBUTION.
# This sample code can be freely distributed, copied, altered, and
# incorporated into other software, provided that it bears the above
# Copyright notice and DISCLAIMER intact.
!include ..\..\..\vacmake.hd

INCS = -I$(SOMBASE)\include
INCLS = stack.xh
IDLFILES = stack.idl

# PRIVCPPFLAGSDLL= /Ms
DLLOBJS = stack.od stacki.od
EXEOBJS = client.obj
PRIVEXELIBS = stack.lib

DEFSPEC=/DEF:stack.def

PRIVLDFLAGSDLL=$(ENTRYFLAG) $(SOMINITOBJ)


all: $(SOMXH_DEPEND) stack.dll client.exe som.ir somdimpl

### -- Build the DLL.
stack.def: stack.idl
stack.exp: stack.idl
stack.lib: stack.def $(DLLOBJS)
stack.dll: stack.exp $(DLLOBJS) stack.lib
stack.lib: stack.def $(DLLOBJS)
stack.od: stack.xih stack.xh stack.cpp

client.exe: stack.lib client.obj
client.obj: $(INCLS) client.cpp

##Build the initialization module from the idl files.
stacki.od:  stacki.c

stacki.c: $(IDLS)
	sc -simod -mdll=stack.dll -mimod=$@ *.idl

### -- Put the IDL descriptions into the Interface Repository.
som.ir: som_ir
som_ir: stack.idl
	-$(SC) -sir -u -mnolock $(INCS) *.idl
	echo x > som_ir


# Build the DSOM Implementation Repository.
somdimpl:
    -regimpl -A -i stackServer2 -p somdsvr.exe
    -regimpl -a -i stackServer2 -c Stack
    -regimpl -L -i stackServer2
    -regimpl -l -i stackServer2
    @echo "" > somdimpl

# Cleanup the DSOM Implementation Repository.
cleanimpl:
        -regimpl -D -i stackServer2
        -erase somdimpl

clean: cleanimpl
	-del som.ir
	-del som_ir
	-del stacki.c

!include ..\..\..\vacmake.tl
